# frozen_string_literal: true
module Admin
  class ResultController < AdminController
    helper_method :sort_column

    # TODO: change context from Candidate to Quiz
    # bypass pundit lockdowns until completed
    after_action :skip_policy_scope
    after_action :skip_authorization
    #

    # TODO: Limit results to the quizzes current_user has access to
    def index
      @candidates = Candidate.where(completed: true)
                             .includes(:recruiter)
                             .order("#{sort_column} #{sort_direction}")
                             .page(params[:page])
    end

    def view
      @candidate = Candidate.find_by(test_hash: params[:test_hash])
      @quiz = @candidate.my_quiz
      @status = QuizStatus.new(@candidate)
      @comments = QuizComment.includes(:user).where(test_hash: @candidate.test_hash).order(:created_at)
      @comment = QuizComment.new
    end

    private

      def sort_column
        Candidate.column_names.include?(params[:sort]) ? params[:sort] : 'completed_at'
      end
  end
end
